package ru.dbotthepony.mc.otm.container;

import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.ListTag;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.item.ItemStack;

public class SimpleSerializableContainer extends SimpleContainer {
	public SimpleSerializableContainer(int i) {
		super(i);
	}

	public SimpleSerializableContainer(ItemStack... p_19152_) {
		super(p_19152_);
	}

	public CompoundTag serializeNBT() {
		CompoundTag tag = new CompoundTag();
		tag.putInt("size", getContainerSize());
		ListTag list = new ListTag();
		tag.put("items", list);

		for (int i = 0; i < getContainerSize(); i++)
			list.add(getItem(i).serializeNBT());

		return tag;
	}

	public static SimpleSerializableContainer of(CompoundTag tag, int fallback_size) {
		if (tag == null)
			return new SimpleSerializableContainer(fallback_size);

		SimpleSerializableContainer container;

		if (tag.contains("size"))
			container = new SimpleSerializableContainer(tag.getInt("size"));
		else
			container = new SimpleSerializableContainer(fallback_size);

		if (tag.get("items") instanceof ListTag list)
			for (int i = 0; i < Math.min(list.size(), container.getContainerSize()); i++)
				if (list.get(i) instanceof CompoundTag get_tag)
					container.setItem(i, ItemStack.of(get_tag));

		return container;
	}
}
