package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.renderer.GameRenderer;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.AndroidStationMenu;

import java.math.BigDecimal;

public class AndroidStationScreen extends AbstractContainerScreen<AndroidStationMenu> {
	private static final ResourceLocation CONTAINER_BACKGROUND = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/android_station.png");
	private final AndroidStationMenu station;

	public AndroidStationScreen(AndroidStationMenu p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);
		station = p_97741_;

		imageWidth = 176;
		imageHeight = 178;
		titleLabelY = 4;

		inventoryLabelY = imageHeight - 92;
	}

	@Override
	public void render(PoseStack p_98418_, int p_98419_, int p_98420_, float p_98421_) {
		this.renderBackground(p_98418_);
		super.render(p_98418_, p_98419_, p_98420_, p_98421_);
		this.renderTooltip(p_98418_, p_98419_, p_98420_);
	}

	@Override
	protected void renderBg(PoseStack pose, float p_97788_, int p_97789_, int p_97790_) {
		RenderSystem.setShader(GameRenderer::getPositionTexShader);
		RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
		RenderSystem.setShaderTexture(0, CONTAINER_BACKGROUND);
		int i = (width - imageWidth) / 2;
		int j = (height - imageHeight) / 2;
		// PoseStack, x, y, image_start_x, image_start_y, rect_size_x, rect_size_y
		this.blit(pose, i, j, 0, 0, this.imageWidth, this.imageHeight);

		BigDecimal energy = station.energy.getDecimal();
		BigDecimal max_energy = station.max_energy.getDecimal();

		double level;

		if (max_energy.equals(BigDecimal.ZERO)) {
			level = 0d;
		} else {
			level = energy.divide(max_energy, MatteryCapability.ROUND_RULES).doubleValue();

			if (level >= 0.98)
				level = 1d;
		}

		if (level > 0.01)
			this.blit(pose, i + 13, j + 15 + 46 - (int) (level * 45d), 176, 0, 7, (int) (level * 46d));
	}
}
